import numpy as np

# The objective function and its gradient
def f(x,y):
    return 0.5*(x**2-4*x*y+8*y**2)
    
def fx(x,y):
    return x-2*y
    
def fy(x,y):
    return -2*x+8*y

# Main 
# Initialization
x0,y0 = 1,2
eps   = 1e-8
t     = 0.001

# Make lists for x,y
xlist,ylist = [],[]
xlist.append(x0)
ylist.append(y0)

# Gradient descent method
xk,yk = x0,y0
iter  = 0
alpha,beta = 0.3,0.9

while True:
    # 1. Delta xk=-grad_f(xk)
    delta_xk, delta_yk=-fx(xk,yk),-fy(xk,yk)
    
    # Backtracking Line Search
    tk = 1
    while True:
        LHS = f(xk+tk*delta_xk,yk+tk*delta_yk)
        RHS = f(xk,yk)+alpha*tk*(-delta_xk*delta_xk-delta_yk*delta_yk)
        if LHS<RHS:
            break
        tk=beta*tk
        
    # 2. xkp1=xk+tk*Delta xk
    xkp1=xk+tk*delta_xk
    ykp1=yk+tk*delta_yk
        
    xlist.append(xkp1)
    ylist.append(ykp1)    
        
    if np.linalg.norm(np.array((xkp1-xk,ykp1-yk)))<eps:
        print("GD converges at iter=",iter)
        break
        
    iter = iter+1
    xk,yk=xkp1,ykp1    

print(iter)
